<style>
    .zm-main {
        width: 100%;
        height: 100%;
    }

    .zm-listview {
        width: 100%;
        height: 60%;
        position: relative;
    }
</style>
<main id="main" class="zm-main">
    <MapView viewstate={mapState}></MapView>
    <ListView></ListView>
</main>
<script>
    import MapView from './maps.html';
    import ListView from './list.html';
    import MapStore from '../store/map-store.js';
    import mapOptions from './mapoptions.json';
    import MapsImplementation from '../common/maps-implementation.js'

    const mapStore = new MapStore();
    export default {
        data() {
            return { mapState: "Loading" } // Loading || Loaded || Error
        },
        store: () => mapStore,
        components: {
            MapView,
            ListView
        },
        oncreate() {
            const self = this;
            const mapSelector = document.getElementById('map');
            const { mapState } = this.get();
            const gmap = this.setupMap(mapSelector,mapOptions);
            this.setupEventMarkers(gmap);
        },
        methods: {
            setupMap(selector, options){
                options.center = new google.maps.LatLng(0, 0);
                const gmap = new MapsImplementation(selector, options);
                this.store.set({ gmap: gmap });
                return gmap;
            },
            setupEventMarkers(map){
                const eventsPromise = this.store.getEvents();
                eventsPromise.then((events) => {
                    var newEvents = [];
                    for (let i = 0; i <= events.length - 1; i++) {
                        newEvents.push(map.geoCodeAddress(events[i]));
                    }
                    newEvents = newEvents.sort(function (a, b) {
                        return new Date(b.startdate) - new Date(a.startdate) && a.category > b.category;
                    });

                    console.log("newEvents",newEvents);
                    this.store.set({ events: newEvents });
                });
            }
        }

    };
</script>